

#define ASCIIHEXDECODE		1
#define ASCII85DECODE			2
#define LZWDECODE					3
#define FLATEDECODE				4
#define RUNLENGTHDECODE		5
#define CCITTFAXDECODE		6
#define DCTDECODE					7


typedef struct filter
	{
	char *input;								/* here is the input stream (compressed)					*/
	unsigned long input_len;		/* Length of the input stream											*/
	char *output;
	unsigned long output_len;
	char *filter_table;					/* Table that contains the filters to be used,
																 zero ends the table														*/
	void *parameters;						/* Extra parameters for the compression algorithm	*/
	};



/*
static char *filters_thumbnail[]={			/*	Extra parameters	*/
	"/ASCIIHexDecode",										/*	no								*/
	"/ASCII85Decode",											/*	no								*/
	"/LZWDecode",													/*	yes								*/
	"/FlateDecode",												/*	yes								*/
	"/RunLengthDecode",										/*	no								*/
	"/CCITTFaxDecode",										/*	yes								*/
	"/DCTDecode",													/*	yes								*/
	NULL};
*/