#include	<ext.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"status.h"
#include	"options.h"
#include	"mp_const.h"
#include	"memdebug.h"
#include	"av_comm.h"
#include	"filters.h"


MFORM motif_ani[8];


	/* get mouse form from the ressource file */
void set_user_mouse_form (OBJECT *adr, MFORM *motif, short mx, short my)
{
	ICONBLK *iblk;
	typedef struct				/* trick to copy all the 32 bytes in one line of C without any variable of pointers :-) */
	{
		short c[16];
	} C32;

	motif->mf_xhot = mx;
	motif->mf_yhot = my;
	motif->mf_nplanes = 1;
	motif->mf_fg = BLACK;
	motif->mf_bg = WHITE;
	iblk = adr->ob_spec.iconblk;
	*(C32 *)motif->mf_mask = *(C32 *)iblk->ib_pmask;
	*(C32 *)motif->mf_data = *(C32 *)iblk->ib_pdata;
}


void init_mouse_pointer (void)
{
	short i;

	for (i = 0; i < 8; i ++)		/* get mouse form from the rsc */
		set_user_mouse_form (&rs_trindex[ANI_MOUSE][i + 1], &motif_ani[i], 8, 8);

	graf_mouse (ARROW, NULL);
}


	/* call every time you want an animated mouse: */
void ani_mouse (void)
{
	static short forme = 1;
	short mode;

	if (x_timers_event (0, 25L))	/* call every 0.125 seconds */
	{
		mode = USER_DEF;
		if (_AESversion >= 0x399)
			mode |= 0x8000;
		graf_mouse (mode, &motif_ani[forme ++]);

		if (forme >= 8)
			forme = 0;

		x_timers_init (0);
	}
}


void Change_pointer(int no)
	{
	short mode;
	MFORM pointer;

	if(no>0)
		{
		set_user_mouse_form (&rs_trindex[E_INFOS][no], &pointer, 8, 8);

		mode = USER_DEF;
		if (_AESversion >= 0x399)
			mode |= 0x8000;
		graf_mouse (mode, &pointer);
		}
	else
		{
		graf_mouse (ARROW, NULL);
		}

	}