#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<ctype.h>
#include	<x_gem.h>
#include	"mypdf.h"
#include	"mypdf.rh"
#include	"files.h"
#include	"status.h"
#include	"typespdf.h"
#include	"options.h"


extern short wh_status;
extern OBJECT *adr_status, *adr_steps;
extern WIND_LIST windows[];
extern X_GEM_INFO *x_gem;
extern struct opt options;


void close_status (void);
void Add_entry2steps(int value);

#ifndef BOOLEAN
	#define BOOLEAN	int
#endif

/*
static char *status_pdf[] =
{
	"....",
	"....",
	"....",
	"....",
	"Loading file...[ ",
	"Reading trailer...[ ",
	"Reading info object...[ ",
	"Reading objects positions...[ ",
	"I'm looking for an object...[ ",
	"I'm checking if the file is a PDF document...[ ",
	"I'm reading objects position - please be patient...[ ",
	"I'm reading documents outline...[ ",
	"I'm reading documents articles threads...[ ",
	"I'm reading the page tree...[ ",
	"I'm reading the page labeling styles...[ ",
	"I'm reading the name tree...[ ",
	NULL
};
*/

static char *progress_pdf[] =
{
	".... [ ",
	".... [ ",
	".... [ ",
	"Uncompressing (ASCII85)... [ ",
	"Uncompressing (ASCIIHex)... [ ",
	"Uncompressing (LZWDecode)... [ ",
	"Uncompressing (Inflate)... [ ",
	"Uncompressing (ASCII85)... [ ",
	"Uncompressing (ASCII85)... [ ",
	"Reading fonts... [ ",
	"Rendering page... [ ",
	"I'm reading the link annotations... [ ",
	"Dithering... [ ",
	NULL
};



	/* display a progress bar in a window */
	/* works now in monochrome video mode */
void Change_status (int status, int value, int max_value)
{
	char *text=NULL;
	int max,i;
	GRECT rd;
	OBJECT *adr=NULL;
	WIND_LIST *wind=NULL;
	struct objects_steps
		{
		int main, done;
		}objects[] = 	{	STEPS_CHECKING, STEPS_CHECKINGD,
										STEPS_LOADING,	STEPS_LOADINGD,
										STEPS_PAGETREE,	STEPS_PAGETREED,
										STEPS_ANNOT,		STEPS_ANNOTD,
										STEPS_OUTLINE,	STEPS_OUTLINED,
										STEPS_INFO,			STEPS_INFOD,
										STEPS_LABELS,		STEPS_LABELSD,
										STEPS_NAMES,		STEPS_NAMESD,
										STEPS_THREAD,		STEPS_THREADD,
										STEPS_THUMB,		STEPS_THUMBD,
										-1,							-1};
	struct objects_steps1
		{
		int object, step;
		}objects1[] = 	{	STEPS_CHECKING, STATUS_PDF_CHECKING_IF_PDF,
											STEPS_LOADING,	STATUS_PDF_LOADING_FILE,
											STEPS_PAGETREE,	STATUS_PDF_PAGE_TREE,
											STEPS_ANNOT,		STATUS_PDF_ANNOTATIONS,
											STEPS_OUTLINE,	STATUS_PDF_OUTLINE,
											STEPS_INFO,			STATUS_PDF_READ_INFO,
											STEPS_LABELS,		STATUS_PDF_PAGE_LABELING,
											STEPS_NAMES,		STATUS_PDF_NAMETREE,
											STEPS_THREAD,		STATUS_PDF_ARTICLE_THREADS,
											STEPS_THUMB,		STATUS_PDF_THUMBNAILS,
											-1,							-1};

	wind = &windows[wh_status];
	if(wind)
		adr = wind->w_dial.d_addr;

 	if(status==STATUS_BAR1_UPDATE || (max_value==0 && value==0 && status!=STATUS_WIN_CLOSE))			/* Update of "...done"	*/
		{
		if (wh_status >= 0)
			{
				if(adr)
					{
					adr[STEPS_BAR_MAIN].ob_width = 2;
					objc_offset (adr, STEPS_BAR_BACK, &rd.g_x, &rd.g_y);
					rd.g_w = adr[STEPS_BAR_BACK].ob_width;
					rd.g_h = adr[STEPS_BAR_BACK].ob_height;
					}

				for(i=0; objects1[i].step!= -1; i++)
					{
					if(value==objects1[i].step)								/* Unshadow the previous step	*/
						{
						text = x_get_ob_text (adr, objects1[i].object);
						text[1] = '2';
						x_redraw_wind (wh_status, DRAW_AES, objects1[i].object, &x_gem->desk_size);
						break;
						}
					}
				x_redraw_wind (wh_status, DRAW_AES, STEPS_BAR_BACK, &rd);
				return;
			}
		}

	if(status==STATUS_BAR3_UPDATE)
		{
		for(i=0; objects1[i].step!= -1; i++)
			{
			if(value==objects1[i].step)								/* Unshadow the previous step	*/
				{
				text = x_get_ob_text (adr, objects1[i].object);
				text[1] = '1';
				adr[objects[i].done].ob_flags &= ~HIDETREE;
				x_redraw_wind (wh_status, DRAW_AES, objects1[i].object, &x_gem->desk_size);
				x_redraw_wind (wh_status, DRAW_AES, objects[i].done, &x_gem->desk_size);
				return;
				}
			}
		}


	if (status == STATUS_WIN_CLOSE)								/* close the window */
	{
		if (wh_status >= 0)
			x_close_wind (wh_status);
		else
			x_gem_alert("[1][Bad window handle][Oops]", 0L);
	}
	else if (status == STATUS_BAR2_UPDATE)				/* update of progress bar */
	{
		if (wh_status >= 0)
		{
			wind = &windows[wh_status];
			adr = wind->w_dial.d_addr;
			max = adr[STEPS_BAR_BACK].ob_width;

			if (max_value <= 0)
				max_value = 1;
			value = (int)((double)value / (double)max_value * (double)max);
			if (value < 2)
				value = 2;
			else if (value > max)
				value = max;

			if (value <= adr[STEPS_BAR_BACK].ob_width)
			{
				adr[STEPS_BAR_MAIN].ob_width = value;
				objc_offset (adr, STEPS_BAR_BACK, &rd.g_x, &rd.g_y);
				rd.g_w = max;
				rd.g_h = adr[STEPS_BAR_BACK].ob_height;
				x_redraw_wind (wh_status, DRAW_AES, STEPS_BAR_BACK, &rd);
			}
		}
	}
	else
	{
		if (wh_status < 0)								/* open the window if necessary */
		{
			for(i=0; objects[i].main!= -1; i++)
				{
				text = x_get_ob_text (adr_steps, objects[i].main);
				text[2] = '2';
				text[1] = '1';
				adr_steps[objects[i].done].ob_flags |= HIDETREE;
				}
			adr_steps[STEPS_BAR_MAIN].ob_width = 2;
			if (x_gem->work_out[13] < 16)
				adr_steps[STEPS_BAR_MAIN].ob_spec.obspec.interiorcol = WHITE;

			wh_status = x_open_wind (-1, -1, adr_steps->ob_width - 1, adr_steps->ob_height - 1, 0, 0, 1, 1, 1, 1, 0, 0, 1, 1, NAME|MOVER, "MyPDF", "", 0L, adr_steps, 0L, 0L, 0L, 0L, (FNCP1)close_status, 0L);

			while (x_form_do (0L) != MU_TIMER);
			return;
		}
		if (wh_status >= 0)
		{
			wind = &windows[wh_status];
			adr = wind->w_dial.d_addr;
			adr[STEPS_BAR_MAIN].ob_width = 2;
			objc_offset (adr, STEPS_BAR_BACK, &rd.g_x, &rd.g_y);
			rd.g_w = adr[STEPS_BAR_BACK].ob_width;
			rd.g_h = adr[STEPS_BAR_BACK].ob_height;
			x_redraw_wind (wh_status, DRAW_AES, STEPS_BAR_BACK, &rd);
			while (x_form_do (0L) != MU_TIMER);
		}
	}
}


void close_status (void)
{
	wh_status = -1;
}



void Add_entry2steps(int value)
	{
	OBJECT *adr=NULL;
	WIND_LIST *wind=NULL;
	char *text;

	wind = &windows[wh_status];
	if(wind)
		adr = wind->w_dial.d_addr;

	if(adr)
		{
		text = x_get_ob_text (adr, value);
		if(text[2] != '0')
			{
			text[2] = '0';
			x_redraw_wind (wh_status, DRAW_AES, value, &x_gem->desk_size);
			}
		}
	}	


#define ADD_MEMORY { buf = x_get_ob_text (adr, TBAR_TB);	\
				if(strstr(buf, "["))	\
					buf[(unsigned long)strstr(buf, " [")-(unsigned long)buf] = 0;	\
				if(options.show_debug.memory && options.show_debug.steps)	\
					sprintf(buf, "%s [%Ld of %Ld objects - %Ld kB free]", buf, value, max_value, ((unsigned long)Malloc(-1))/1000);	\
				if(options.show_debug.memory && !options.show_debug.steps)	\
					sprintf(buf, "%s [%Ld kB free]", buf, ((unsigned long)Malloc(-1))/1000);	\
				if(!options.show_debug.memory && options.show_debug.steps)	\
					sprintf(buf, "%s [%Ld of %Ld objects]", buf, value, max_value);	\
				objc_offset (adr, TBAR_TB_BACK, &rd.g_x, &rd.g_y);	\
				rd.g_w = adr[TBAR_TB_BACK].ob_width;	\
				rd.g_h = adr[TBAR_TB_BACK].ob_height;	\
				x_redraw_wind (window, DRAW_ALL, TBAR_TB_BACK, &rd); }


	/* display a progress bar in a pdf window */
	/* works now in monochrome video mode */
void Change_progress_bar (int status, int window, unsigned long value, unsigned long max_value)
{
	char *buf=NULL;
	int max;
	GRECT rd;
	OBJECT *adr;
	WIND_LIST *wind;

	if (status == STATUS_BAR1_UPDATE && options.show_debug.bar)
	{
		if (x_timers_event (1, 100L) || ! value)		/* call every 0.5 seconds or if bar is reset */
		{
			if (window >= 0 && options.show_debug.bar)
			{
				wind = &windows[window];
				adr = wind->w_dial.d_addr;
				max = adr[PBAR_TB - 1].ob_width;

				if (max_value <= 0)
					max_value = 1;
				value = (int)((double)value / (double)max_value * (double)max);

				if (value < 2)
					value = 2;
				else if (value > max)
					value = max;

				if (value != adr[PBAR_TB].ob_width)
				{
					adr[PBAR_TB].ob_width = value;
					adr[PBAR_TB2].ob_width = 0;
					objc_offset (adr, PBAR_TB, &rd.g_x, &rd.g_y);
					rd.g_w = max;
					rd.g_h = adr[PBAR_TB - 1].ob_height;
					x_redraw_wind (window, DRAW_ALL, PBAR_TB - 1, &rd);
				}
			}
			x_timers_init (1);
		}
	}
	else if(status == STATUS_BAR3_UPDATE && options.show_debug.bar)
	{
		if (x_timers_event (2, 20L) || ! value)		/* call every 0.5 seconds or if bar is reset */
		{
			if (window >= 0)
			{
				wind = &windows[window];
				adr = wind->w_dial.d_addr;
				max = adr[PBAR_TB].ob_width;

				ADD_MEMORY

				if (max_value <= 0)
					max_value = 1;
				value = (int)(((double)value / (double)max_value) * (double)max);

				if (value < 2)
					value = 2;
				else if (value > max)
					value = max;

				if (value != adr[PBAR_TB2].ob_width && options.show_debug.bar)
				{
					adr[PBAR_TB2].ob_width = value;
					objc_offset (adr, PBAR_TB - 1, &rd.g_x, &rd.g_y);
					rd.g_w = max;
					rd.g_h = adr[PBAR_TB - 1].ob_height;
					x_redraw_wind (window, DRAW_ALL, PBAR_TB-1, &rd);
				}
			}
			x_timers_init (2);
		}
	}
	else
	{
		wind = &windows[window];
		adr = wind->w_dial.d_addr;
		buf = calloc(1, 256);
		if(progress_pdf[status]!=NULL && buf)
			strcpy (buf, progress_pdf[status]);
		else if(buf)
			strcpy (buf, "Unknown command...");

		if(buf)
			{
			x_suspend_text (x_gem->sys_handle, buf, adr[TBAR_TB].ob_width, 0);
			x_set_ob_text (adr, TBAR_TB, buf);
			objc_offset (adr, TBAR_TB, &rd.g_x, &rd.g_y);
			rd.g_w = adr[TBAR_TB].ob_width;
			rd.g_h = adr[TBAR_TB].ob_height;
			x_redraw_wind (window, DRAW_ALL, TBAR_TB_BACK, &rd);
			free(buf);
			}
	}
}