#include	<mgem.h>
#include	<portab.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<tos.h>
#include	<ctype.h>
#include	"typespdf.h"
#include	"info_pdf.h"
#include	"files.h"
#include	"status.h"


char *Read_line(struct files_pdf *);
BOOLEAN add_object_position(int , long , long , char );
char *Read_prev_line(struct files_pdf *);
char *read_prev_line(int );
unsigned long Read_object_no(struct files_pdf *);
char *Read_command(struct files_pdf *);


extern struct PDF_Info *root_pdf_info_find;

static unsigned long go_back_pos[50];


void zero_go_back(void)
{
	int i;

	for(i=0; i<20; i++)
		go_back_pos[i] = 0;
}


int find_empty_go_back(void)
{
	int i;

	for(i=0; i<20; i++)
		if(go_back_pos[i]==0)
			return(i);

	return(0);
}	

int find_last_go_back(void)
{
	int i;

	for(i=20; i>-1; i--)
		if(go_back_pos[i]!=0)
			return(i);

	return(0);
}	


BOOLEAN GoBack(struct PDF_Info *info)
{
	info->file_info->actual_pos = go_back_pos[find_last_go_back()];
	go_back_pos[find_last_go_back()] = 0;

	return(TRUE);
}


BOOLEAN GoToObject(struct PDF_Info *info, unsigned int obj)
{
	unsigned long act_pos=0;
	char *buffer=NULL, position[20]={0};
	struct object_position *object=NULL;

	if(info->file_info->buffer!=NULL && info->file_info->handle<=0)
		buffer=info->file_info->buffer;

	go_back_pos[find_empty_go_back()] = info->file_info->actual_pos;

	object = info->obj_position.first_object;

	if(object)
		{
		while(object)
			{
			if(obj>=(unsigned int)object->start_object && obj<(unsigned int)object->end_object)
				{
				if(act_pos==0 || object->type==0)
					{
					act_pos = (unsigned long)((obj - (unsigned int)object->start_object)*20UL);
					if(buffer!=NULL)
						act_pos = (unsigned long)atol(&buffer[(unsigned long)object->adress + act_pos]);
					else
						{
						Fseek((unsigned long)object->adress + act_pos, info->file_info->handle, 0);
						read(info->file_info->handle, &position[0], 20);
						act_pos = (unsigned long)atol(&position[0]);
						}
					info->file_info->actual_pos = act_pos;
					}
				}
			object = object->next;
			}
		return(TRUE);
		}
	return(FALSE);
}


BOOLEAN Load_objects (struct PDF_Info *info, int type)
{
	char *line;		/*	, *buffer=NULL;	*/
	struct files_pdf *file = info->file_info;
	char character=0;
	long start_object=-1, objects=0, length;
	unsigned long max_obj=2;
	struct object_position *first_object=info->obj_position.first_object, *next_object=NULL, *object=NULL;

	if(file)
	{
/*		if(file->handle<=0)
			buffer = &file->buffer[file->actual_pos];
*/
/*		Change_status(STATUS_PDF_OBJECT_POSITIONS, 0, 0);	*/
		Change_status(STATUS_BAR1_UPDATE, STATUS_PDF_OBJECT_POSITIONS, 0);
		object = next_object = first_object = info->obj_position.first_object;


		if(object!=NULL)														/* Let's find first the last object list in the chain	*/
			{
			while(object->next!=NULL)									/* First we have to go on the end of the chain				*/
				{
				if(object->next)
					object = object->next;
				else
					break;
				}
			object=object->prev;
			}

		line = Read_line(file);


		if(first_object==NULL)										/* Now we have to alloc memory for a new objects position	*/
			{
			object = first_object = calloc(1, sizeof(struct object_position));
			memset(first_object, 0, sizeof(struct object_position));
			info->obj_position.first_object = first_object;
			}
		else
			{
			next_object = calloc(1, sizeof(struct object_position));
			memset(next_object, 0, sizeof(struct object_position));
			if(object==NULL)
				{
				object = info->obj_position.first_object;
				while(object->next!=NULL)
					object = object->next;
				object->next = next_object;
				next_object->prev = object;
				}
			else
				{
				object->next = next_object;
				next_object->prev = object;
				}
			object = next_object;
			}
		object->type = type;


/*		if (strstr(line, "xref") != NULL)
*/		{
			while (strstr (line, "trailer") == NULL && objects < max_obj)
			{
				if ((length = strlen(line)) <= 20 && isdigit (line[0]) && strstr (line, "f") == NULL && strstr (line, "n") == NULL)		/* Objects numbers */
				{
					start_object = atol (line);
					line = strstr (line, " ");
					max_obj = atol (line);
					if(info->obj_position.adress1==NULL)
					{
						object->start_object = (int)start_object;
						object->end_object = (int)(start_object+max_obj);
						object->adress = (void*)file->actual_pos;

						file->actual_pos += max_obj*20;
					/*	line = Read_line(file);	*/

						if(strcmp(line, "trailer")==0)
						{
							if(file->handle>0)
								Fseek(file->actual_pos, file->handle, 0);

							return(TRUE);
						}
						else
						{
							next_object = calloc(1, sizeof(struct object_position));
							memset(next_object, 0, sizeof(struct object_position));
							object->next = next_object;
							next_object->prev = object;
							object = next_object;

							if(file->buffer!=NULL && file->handle<=0)								/* Do we read the datas from memory?		*/
								{																											/* yes																	*/
								while(file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\n')
									file->actual_pos--;
								file->actual_pos--;
								while(file->buffer[file->actual_pos]!='\r' && file->buffer[file->actual_pos]!='\n')
									file->actual_pos--;
								file->actual_pos++;
								}
							else																										/* No, we have to read it from a file		*/
								{
								while(character!='\r' && character!='\n')
									{
									read(file->handle, &character, 1);
									Fseek(-2, file->handle, 1);
									file->actual_pos--;
									}
								file->actual_pos--;
								read(file->handle, &character, 1);
								Fseek(-2, file->handle, 1);

								while(character!='\r' && character!='\n')
									{
									read(file->handle, &character, 1);
									Fseek(-2, file->handle, 1);
									file->actual_pos--;
									}
								file->actual_pos++;

								close(file->handle);
								file->handle = open(file->name ,O_RDONLY);
								}
						}
					}
				}
				line = Read_line(file);
			}
		}

		if(file->handle>0 && file->buffer==NULL)								/* Are we working on a file?	*/
			{
			close(file->handle);
			file->handle = open(file->name ,O_RDONLY);
			Fseek(file->actual_pos, file->handle, 0);
			}

		Change_status(STATUS_BAR3_UPDATE, STATUS_PDF_OBJECT_POSITIONS, 0);

		if(strstr (line, "trailer")!=NULL)											/* If there is another one trailer after the object position we have to give back TRUE	*/
			return(TRUE);
		else
			return(2);																						/* in other case 2																																			*/
	}

	length = length;
	return(FALSE);
}



/* **************************************************************	*/
/* Find_PDF_info																									*/
/* v. 1.0 (14.10.2001) - Rafal Kawecki                          	*/
/* **************************************************************	*/
/*                                                              	*/


unsigned long Find_PDF_info (struct PDF_Info *info)
{
	char *line;
	struct files_pdf *file = info->file_info;
	char *buffer = &file->buffer[file->actual_pos];
	long start_object=-1, max_obj=2;
	long pos;
	unsigned long info_no;
	unsigned long prev_pos;
	unsigned long prev_position;			/* Where it was on the beginning	*/

	prev_position = file->actual_pos;
	root_pdf_info_find = info;

	if(buffer!=NULL)
	{
		line = Read_line(file);
		Change_status(STATUS_PDF_OBJECT_POSITIONS, 0, 0);
		/*Change_status(STATUS_BAR1_UPDATE, 0, 0);*/

		pos = (ULONG)strstr(buffer, "trailer") - (ULONG)buffer;
		info->file_info->actual_pos += pos - 5;
		line = Read_line(file);

		if(strstr(line, "trailer")!=NULL)		/* Is it the TRAILER?			*/
		{
			line = Read_command(file);				/* Read first command			*/
			while(strstr(line, ">>")==NULL)		/* Read until ">>" found	*/
			{
				switch(find_command(trailer_commands, line))		/* What command has been loaded?	*/
				{
					case INFO_OBJECT:										/* Info from trailer about the info object	*/
						info_no = Read_object_no(file);
						break;
					case PREV_OBJECT:										/* Info from trailer about the prev object	*/
						prev_pos = Read_object_no(file);
						break;
				}
				line = Read_command(file);						/* Read every next command									*/

				if(line==NULL)												/* Are there still commands in the trailer?	*/
					break;
			}
		}


		if(info_no)			/* Did MyPDF found the INFO Object number	*/
		{
			info->file_info->actual_pos = prev_position;		/* Go to the beginning of the position list	*/

			line = Read_line(file);												/* Read the list header		*/

			if(strstr(line, "xref")!=NULL)
			{
				line = Read_line(file);											/* Read the start and maximum objects info	*/

				if ((strlen(line)) <= 20 && isdigit (line[0]) && strstr (line, "f") == NULL && strstr (line, "n") == NULL)		/* Objects numbers */
				{
					start_object = atol (line);
					line = strstr (line, " ");
					max_obj = atol (line);
				}

				if(start_object<info_no && (start_object+max_obj)>info_no)
				{																						/* The info object is in the original object list	*/
					info->file_info->actual_pos += info_no*20;
					line = Read_line(file);
/*					atol (line);			/* Position of the info object	*/	*/
				}
				else													/* no, the info object position is in the PREV list	*/
				{
					info->file_info->actual_pos = prev_pos;			/* Load the PREV object position	*/
					line = Read_line(file);
					if(strstr(line, "xref")!=NULL)
					{
						line = Read_line(file);
						if ((strlen(line)) <= 20 && isdigit (line[0]) && strstr (line, "f") == NULL && strstr (line, "n") == NULL)		/* Objects numbers */
						{
							start_object = atol (line);
							line = strstr (line, " ");
							max_obj = atol (line);
						}
						if(start_object<info_no && (start_object+max_obj)>info_no)
						{																						/* The info object is in the original object list	*/
							info->file_info->actual_pos += info_no*20;
							line = Read_line(file);
/*							atol (line);			/* Position of the info object	*/	*/
						}
					}
				}
			}
		}
	}
	return(0);
}