#ifndef _WINDINFO
#define _WINDINFO


#define OB_WHITE_PAGE struct OB_WHITE_PAGE
OB_WHITE_PAGE
{
	short pxy[4];
};


#define OB_Tf struct OB_Tf
OB_Tf
{
	short TT_id;
	short italic_angle;
	short effect;
};


#define OB_Tj struct OB_Tj
OB_Tj
{
	short color;
	unsigned long Tfs;
	short rotate;
	unsigned long pos_x;
	unsigned long pos_y;
	BOOLEAN TJ;
	short *dis_x;
	short *text;
	short len;
	unsigned long Tc;
	unsigned long Tw;
	unsigned long Th;
	struct fonts *actual_font;
};

#ifndef GRAPH_STATE
	#include	"graf_sta.h"
#endif

#define OB_PATH_CONSTRUCTION struct OB_PATH_CONSTRUCTION
OB_PATH_CONSTRUCTION
{
	struct graphical_state path;
	struct path_objects *objects;
	unsigned long done_objects;
};


#define OB_Picture struct OB_Picture
OB_Picture
{
	struct picture *picture;
	short a,b,c,d,e,f;
	char *stream;
};

#define PDF_OBJECT struct PDF_OBJECT
PDF_OBJECT
{
	short type;												/* type of object */

	union PDF_OBJECT_SPEC									/* object's specific infos */
	{
		OB_Tf Tf;
		OB_Tj Tj;
		OB_PATH_CONSTRUCTION path_construction;
		OB_WHITE_PAGE white_page;							/* er: not part of pdf but usefull ;) */
		OB_Picture Pic;
	} spec;

	PDF_OBJECT *next;										/* next object (0 = last object) */
};


#define WIND_INFO struct WIND_INFO
WIND_INFO
{
	struct PDF_Info *pdf_info;								/* informations about document */

	PDF_OBJECT *pdf_object;									/* all vdi objects to draw */

	USERBLK outline_tb;										/* for the outline */
	short outline_pos;
	short outline_number;
	short outline_pos_x;
	short max_width;
};

#endif
